<template>
  <mt-connexion-template>
    <template v-slot:partie-gauche-boutton>
      <div class="has-text-weight-bold is-size-5 is-size-7-mobile">Pas encore inscrit ?</div>
      <b-button
        class="mt-button is-secondary is-size-7 has-text-weight-semibold mt-borderless"
        @click="popUpNousRejoindreOpen = true"
      >
        Nous rejoindre
      </b-button>
      <mt-modal-ok :ouvert.sync="popUpNousRejoindreOpen" titre="Nous rejoindre" class="mt-nous-rejoindre">
        <template #default>
          <p class="has-text-justified">
            Pour pouvoir utiliser METIIS, vous devez avoir reçu une invitation de la part de votre Commandant d’Unité ou
            votre Chef de Section directement sur votre boîte mail.
          </p>
          <br />
          <p class="has-text-justified">
            Le lien d’activation de votre compte est valable 15 jours après réception.
          </p>
          <br />
          <p class="has-text-justified">
            <b>Si vous n’avez pas reçu de lien d’inscription, merci de contacter votre supérieur hiérarchique.</b>
          </p>
          <br />
          <p class="has-text-left">
            À bientôt, <br />
            L’équipe METIIS.
          </p>
        </template>
        <template #buttons>
          <div></div>
        </template>
      </mt-modal-ok>
    </template>
    <template v-slot:partie-droite>
      <form @submit.prevent="login(user)">
        <h2>Se connecter</h2>
        <b-field label="Identifiant">
          <b-input v-model="user.username" placeholder="E-mail" required class="input-login" />
        </b-field>

        <b-field label="Mot de passe">
          <b-input
            v-model="user.password"
            placeholder="Mot de passe"
            type="password"
            password-reveal
            required
            class="input-login"
          />
        </b-field>
        <p>
          <span class="forget-password cursor-as-pointer" @click="popUpNouveauMotDePasseOpen = true"
            >Mot de passe oublié ?</span
          >
        </p>

        <b-button class="mt-button is-size-7 has-text-weight-semibold" type="is-primary" native-type="submit">
          Se connecter
        </b-button>
      </form>
      <mt-modal-ok
        :ouvert.sync="popUpNouveauMotDePasseOpen"
        titre="Saisissez votre adresse e-mail"
        title-position="left"
        button="Valider"
        class="mt-modal-stretch mt-modal-pwd"
        @action="renewPassword"
      >
        <form class="column is-full columns">
          <b-field class="column is-full ">
            <b-input
              key="user-email"
              v-model="user.username"
              placeholder="E-mail"
              required
              class="input-login"
              expanded
            />
          </b-field>
        </form>
      </mt-modal-ok>

      <mt-modal-ok
        :ouvert.sync="popUpConfirmationChangementMotDePasseOpen"
        titre="Un e-mail a bien été envoyé."
        button="Retour à l’accueil"
        class="mt-modal-stretch mt-modal-pwd"
      >
        <div class="textAlignement">
          <p>
            Un mail de réinitialisation de mot de passe vous a été envoyé.
            <br />
            S'il s'agit de votre première connexion, une invitation à vous inscrire vous sera renvoyée.
          </p>
        </div>
      </mt-modal-ok>
    </template>
  </mt-connexion-template>
</template>

<script>
import MtConnexionTemplate from '~/components/connexion/connexion-template';
import MtModalOk from '~/components/modal/mt-modal-ok';

export default {
  layout: 'simple',
  components: {
    MtModalOk,
    MtConnexionTemplate,
  },
  data() {
    return {
      user: {
        username: null,
        password: null,
      },
      from:
        this.$nuxt.context.from && this.$nuxt.context.from.path !== this.$route.path
          ? this.$nuxt.context.from.path
          : null,
      popUpNouveauMotDePasseOpen: false,
      popUpNousRejoindreOpen: false,
      popUpConfirmationChangementMotDePasseOpen: false,
    };
  },
  methods: {
    async login(data) {
      try {
        await this.$auth.login({ data });
        const monOrganisme = this.$store.state.auth.user.affectation.organisme;
        if (this.$store.getters['context/isAdminLocal']) {
          const organismes = await this.$api.organismes.affectableAllowed();
          await this.$store.dispatch('context/setOrganismes', organismes);
          let index = 0;
          for (let i = 0; i < organismes.length; i += 1) {
            if (organismes[i].id === monOrganisme.id) {
              index = i;
              break;
            }
          }
          await this.$store.dispatch('context/setOrganisme', organismes[index]);
        } else {
          await this.$store.dispatch('context/setOrganisme', monOrganisme);
        }
        await this.$store.dispatch('context/setGroupesSelected', []);
        let redirect = this.from || this.$auth.options.redirect.home || '/';
        if (redirect.includes('/invitation/')) {
          redirect = '/';
        }
        this.$router.push(redirect);
        this.$buefy.toast.open({
          message: 'bienvenue',
          type: 'is-success',
        });
      } catch ({ response: { status }, message }) {
        this.$buefy.notification.open({
          message:
            'Impossible de vous connecter.</br> ' +
            'Merci de vérifier votre identifiant et votre mot de passe.</br>' +
            'Si le problème persiste, contactez votre responsable hiérarchique pour </br>' +
            "confirmer votre identifiant et vérifier que votre compte n'est pas verrouillé.",
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    validateEmail(email) {
      const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },
    async renewPassword() {
      if (!this.validateEmail(this.user.username)) {
        this.$buefy.notification.open({
          message: "L'addresse mail que vous avez saisie n'est pas valide.",
          type: 'is-warning',
          duration: 5000,
        });
      } else {
        this.popUpConfirmationChangementMotDePasseOpen = true;
        await this.$api.utilisateurs.demandeNouveauMotDePasse(this.user);
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
/deep/ {
  .mt-nous-rejoindre {
    .mt-modal-titre {
      font-size: 2rem;
      font-weight: 300;
      line-height: 0.85;
      align-self: flex-start;
      margin-bottom: 3rem;
      margin-top: 1rem;
    }
    .mt-modal-message {
      color: $grey-dark;
      font-size: 0.9375rem;
      font-weight: normal;
      line-height: 1.27;
    }
  }
  .mt-modal-pwd {
    .mt-modal-titre {
      margin-bottom: 0.2rem;
    }
  }
}
.textAlignement {
  text-align: center;
}
</style>
